<?php 
	$specialUserID = 1089234;
	if (isset($_GET['userID'])) {
		$specialUserID = $_GET['userID'];
	}	
	$isIpad = 0;
	if(isset($_GET['ipad'])){
		$isIpad = 1;
	}
?>

<!DOCTYPE html>
<html lang="en">
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
		<meta name="apple-mobile-web-app-capable" content="yes" /> <!-- load fullscreen/chromeless if added to the homescreen -->
		<link rel="apple-touch-startup-image" href="./images/loading-page.png"> <!-- image to display while loading -->
		<link rel="apple-touch-icon" title="Teague" href="./images/app-icon.png" /> <!-- icon to use when saved to homescreen -->
		<meta name="apple-mobile-web-app-status-bar-style" content="black"> <!-- black/white/black-translucent: use 'bloack-translucent' if you want the page to extend into  toolbar.-->
		<?php
			if($specialUserID != 0){
				if(!$isIpad){
					echo '<meta name="viewport" content="user-scalable=no, user-scrollable=yes, width=480, initial-scale=1.5, maximum-scale=1.5"><!-- override iphone standard browser touch behavior -->';
				}else{
					echo '<meta name="viewport" content="user-scalable=no, user-scrollable=yes, width=480, initial-scale=3.2, maximum-scale=3.2"><!-- override iphone standard browser touch behavior -->';
				}
			}else{
				echo '<meta name="viewport" content="user-scalable=no, user-scrollable=yes, width=device-width, initial-scale=1.0, maximum-scale=1.0"><!-- override iphone standard browser touch behavior -->';
			}
		?>
		
		<link rel="icon" type="image/png" href="../../favicon.png" />
		<title>TEAGUE : IxD Project Flow</title>
		<!-- 
		##
		## (c)2010 Teague, Adam Kumpf 
		## questions? akumpf@teague.com
		## Licensed under Creative Commons Attribution-Share Alike 3.0
		## Use it, make it better, and let others do the same. 
		##
		-->
		<!-- CSS STYLE ELEMENTS (if you have lots of styles, put them in a seperate file and link to them instead). -->
		<style>
			*{
				font-family: Helvetica, sans-serif;
			}
		
			.absObj {
				position: absolute;
			}
			/*
				-moz-border-radius: 10px;
				-webkit-border-radius: 10px;
				border: 2px solid #555555;
			*/
			
			.todayEntry {
				position: relative;
			}
			
			.todayName {
				position: absolute;
				padding-top: 6px;
				left: 0px;
				width: 115px;
				height: 25px;
				line-height: 25px;
				color: #CCCCCC;
			}
			.todayNumber {
				position: absolute;
				padding-top: 6px;
				left: 115px;
				width: 54px;
				height: 25px;
				line-height: 25px;
				color: #CCCCCC;
			}
			.todaySparkline {
				position: absolute;
				left: 169px;
				width: 96px;
				height: 25px;
				color: #CCCCCC;
			}
			.titleDiv {
				font-weight: 500;
				border-bottom: 1px solid #333333;
				width: 310px;
				height: 20px;
				text-align: center;
				color: #CCCCCC;
				font-family: Helvetica;
				margin-top: 3px;
			}
			
			.modularInfoDiv {
				color: #FFFFFF; 
				width: 310px;
				margin-top: 5px;
				margin-left: 5px;
				margin-right: 0px;
				-moz-border-radius: 10px;
				-webkit-border-radius: 10px;
				background: #181818;
				border: none;
				display: inline-block;
				vertical-align: top;
				height: 150px;
			}
			
			#thinHeader {
				color: #CCCCCC;
				width: 100%;
				height: 20px;
				font-size: 14px; 
				text-align: center;
				padding-top: 3px;
				background: #222222;
				border-bottom: 1px solid #111111;
				float: center;
			}
			
		</style>
	</head>
	<body style="background: #000000;">	 
	<!-- PAGE CONTENT... -->
		<div id="appContainer" style="background: #000000; position: absolute; top: 0px; left: 0px; width: 100%; overflow: none"> <!-- width: 320px; height: 480px; -->
			<!-- ############################################### -->
			<!-- ######## static App content goes here. ######## -->
			<!-- ############################################### -->
			<!-- TIPS & TRICKS
				Normal mouse/touch interaction is eaten up by default, so if you want the click to pass to element as normal -- such as 
				clicking on a text input to bring up the keyboard for text entry -- you'll need to call focus(); to unfocus later, call blur().
				EX: <input id="formInputField" type="text" name="n" onmousedown="$(this).focus();" ontouchstart="$(this).focus();"/>
				
				Child elements don't pass mouse/touch events to their parents by default, so if you make a DIV movable, but 
				then place something on it (like an image or text), the elements will not move when start your press on the child.
				To work around this, either place the image as background, or pass all click event through to parent (how?!).
				EX: <div id="uniqueObjID" class="absObj touchMY" style="background: url('./image.png'); height: 460px; width: 320px;">
				EX: ?? how to pass mouse event through automaticallly? (glass overlay?).
			-->
			
			<!-- fixed elements (background, containers, regions, etc.) -->
			
			
			<!-- movable objects (draggable via their classes) -->
				<div id="thinHeader">Last Updated: <span id="headerUpdateTime">...</span></div>
				
				<div class="modularInfoDiv" >
					<div class="titleDiv">Faucet</div> 
					<div id="waterToday" style="position: relative; width: 300px; left: 5px;">
						<center><br/><br/><img src='./images/loading.gif'/></center>
					</div>
				</div>				
				
				<div class="modularInfoDiv">
					<div class="titleDiv">Cumulative water today</div> 
					<div id="waterIntegral" style="position: relative; width: 300px; left: 5px;">
						<center><br/><br/><img src='./images/loading.gif'/></center>
					</div>
				</div>
				
				<div class="modularInfoDiv">
					<div class="titleDiv">Water this week</div> 
					<div id="waterThisWeek" style="position: relative; width: 300px; left: 5px;">
						<center><br/><br/><img src='./images/loading.gif'/></center>
					</div>
				</div>
				
				<div class="modularInfoDiv">
					<div class="titleDiv">Water this month</div> 
					<div id="waterThisMonth" style="position: relative; width: 300px; left: 5px;">
						<center><br/><br/><img src='./images/loading.gif'/></center>
					</div>
				</div>
				
				<div class="modularInfoDiv">
					<div class="titleDiv">Relative use by time of day</div> 
					<div id="waterDayAverage" style="position: relative; width: 300px; left: 5px;">
						<center><br/><br/><img src='./images/loading.gif'/></center>
					</div>
				</div>
				
				<div class="modularInfoDiv">
					<div class="titleDiv">Relative temp by time of day</div> 
					<div id="waterDayAveTemp" style="position: relative; width: 300px; left: 5px;">
						<center><br/><br/><img src='./images/loading.gif'/></center>
					</div>
				</div>
				
				<div class="modularInfoDiv">
					<div class="titleDiv">Total water cost ($)</div> 
					<div id="waterCost" style="position: relative; width: 300px; left: 5px;">
						<center><br/><br/><img src='./images/loading.gif'/></center>
					</div>
				</div>
				
				<div class="modularInfoDiv">
					<div class="titleDiv">Average Power (W)</div> 
					<div id="waterPower" style="position: relative; width: 300px; left: 5px;">
						<center><br/><br/><img src='./images/loading.gif'/></center>
					</div>
				</div>
				
				<div class="modularInfoDiv">
					<div class="titleDiv">Debug info</div> 
					<div id="waterDebug" style="position: relative; width: 300px; left: 5px;">
						<center><br/><br/><img src='./images/loading.gif'/></center>
					</div>
				</div>
				
				<div style="margin-bottom: 10px;">
				</div>
				
				<canvas id="renderCanvas" style="position: absolute; left: 16px; top: 100px; width: 288px; height: 75px; background: #222222; display: none;" width="288" height="75"></canvas>
				<!--
				<div id="apps" class="absObj touchMX boundMX" minBX="-1920" maxBX="320" style="left: -320px; top: 20px; background: url('./images/iphone/iphone_allapps_min.png'); height: 350px; width: 1920px;">
					<div class="absObj" style="left: 35px; top: 9px;">
						<input id="formInputField" type="text" name="n" style="width: 250px; height: 22px; border: 0px solid #FFFFFF; font-size: 18px; background-color: transparent; color: #AAAAAA;" value="Search..." title="Search..." onfocus="if(/Search\.\.\./i.test(this.value)){this.value='';setStyle(this,'color','#000000');}" onblur="if(this.value==''){this.value='Search...';setStyle(this,'color','#AAAAAA');}" onmousedown="$(this).focus();" ontouchstart="$(this).focus();"/>
					</div>
				</div>
				<div id="specialapps" class="absObj touchMY boundMY" minBY="0" maxBY="370" style="left: 0px; top: 390px; background: url('./images/iphone/iphone_specialapps_drawer.png'); height: 460px; width: 320px;"></div>
				-->
			
			<!-- dynamicly updated content (labels, graphics, feedback, etc.) -->
			
			
			<!-- ############################################ -->
			<!-- ######## end of static App content. ######## -->
			<!-- ############################################ -->
		</div>
		
		<!-- ################################################ -->
		<!-- ######## dynamic App content goes here. ######## -->
		<!-- ################################################ -->
			
		<!-- 
		## Add a nice set of javascript libraries to make prototyping and development easy/efficient.
		## Includes: JQuery, Multitouch-fake, Multitouch-simplified, HTML5 Utils, Nav-simplifier, etc.  -->
		<script type="text/javascript" src="./js/teagueproto.js"></script>
		
		<!-- javascript in testing.. this is where the bulk of the code goes until it can be refined and placed in a separate file. -->
		<script type="text/javascript" charset="utf-8">
		//<![CDATA[
			//
			// some notes on using simplified multitouch:
			// ----------------------------------------------------------------------------------------------
			//  * basic multitouch functionality can be easily accomplished by setting the element's class:
			//    >> touchMX   = allow multitouch movement in X direction
			//    >> touchMY   = allow multitouch movement in Y direction
			//    >> touchMRequiresTwo = require two fingers for Move X/Y interaction.
			//    >> touchRot  = allow multitouch 2 finger rotation
			//    >> touchSca  = allow multitouch 2 finger scalling
			//    >> touchTop  = pull object to top when touched (in front of other elements).
			//    >> boundMX   = bound the object's X movement (specify with attributes: minBX, maxBX).
			//    >> boundMY   = bound the object's Y movement (specify with attributes: minBY, maxBY).
			//    >> boundSca  = bound the object's scale (specify with attributes: minSca, maxSca).
			// * you can get all of the touch data through the event (e)
			//    >> e.touches[]               = array of touches (length can be used to know number of fingers)
			//    >> e.touches[i].identifier   = id of element being touched 
			//    >> e.touches[i].target       = the actual element being touched (if any)
			//    >> e.touches[i].clientX      = the global X position of the touch point
			//    >> e.touches[i].clientY      = the global Y position of the touch point
			//    >> e.touches[i].target.posX  = the 'left+ xfm_tx' property of the element being touched
			//    >> e.touches[i].target.posY  = the 'top + xfm_ty' property of the element being touched
			// * you can nicely set the position of the touched element with setTouchedElementPos(x,y); 
			// * there's also an array of movingObjects[] that automatically updates (handy for low-level stuff).
			// * If you want to turn on simulated two finger interaction when using a mouse, do this:
			//    >> touchFakeTwoFingerForMouseInput = true;
			// * There is are shortcut helpers for making code more compact:
			//    >> did("uniqueID");  // performs: document.getElementById("uniqueID");
			// * Another way to use touch is to add functionality specific to a particular element (with a unique id attribute).
			//    >> did("uniqueID").onTouchDown = function(info) { }; // Touch started           >> info has {x, y, s, r, ax, ay}
			//    >> did("uniqueID").onTouchMove = function(info) { }; // Touch moved             >> info has {x, y, s, r, ax, ay}
			//    >> did("uniqueID").onTouchUp   = function(info) { }; // Touch released/stopped  >> info has {x, y, s, r, ax, ay}
			// ----------------------------------------------------------------------------------------------
			//
			/*
				//
				// example of hooking up some touch interaction to an output.
				//
				did("volKnob").onTouchDown = function (info) {
					// what to do when the object is first touched.
				}
				did("volKnob").onTouchMove = function (info) {
					// what to do when the object is moved.
					did("volDiv").innerHTML = "VOLUME: " + ((info.x-10)/2.0);
				}
				did("volKnob").onTouchUp = function (info) {
					// what to do when the object is released.
				}
			*/	
			
			

			var allUsers = []; // new Array();
			
			function clearAndLoadAllUserData(){
				allUsers = []; // clear out the array.
				userDataReturnedSoFar = 0;
				getUserData();
			}
			
			var userDataReturnedSoFar = 0;
			var AUTO_UPDATE_TIMEOUT = 30000; // refresh every 30 seconds.
			
			<?php
				echo "
				var specialUserID = ".$specialUserID.";
				// AUTO_UPDATE_TIMEOUT = 3000; // make update time 10 seconds (more active).
				";
			?>

			function getUserData(){
				console.log("Fetching user data...");
				
				allUsers.push(new User(1089234, "Teague Faucet", "#eab44d"));
				allUsers.push(new User(1089235, "Erick's Shower", "#4db4ea"));
				allUsers.push(new User(1089236, "Mo's Shower", "#4dea6b"));
				allUsers.push(new User(1089237, "Adam's Shower", "#ea4ddd"));
				$.ajax({ url: "./getDataFromFlow.php?userID="+allUsers[0].userID, success: function(data){
					parseDataAndAddToUser(data, allUsers[0]);
					userDataReturnedSoFar++;
					updateUIWhenReady();
				}});
				$.ajax({ url: "./getDataFromFlow.php?userID="+allUsers[1].userID, success: function(data){
					parseDataAndAddToUser(data, allUsers[1]);
					userDataReturnedSoFar++;
					updateUIWhenReady();
				}});
				$.ajax({ url: "./getDataFromFlow.php?userID="+allUsers[2].userID, success: function(data){
					parseDataAndAddToUser(data, allUsers[2]);
					userDataReturnedSoFar++;
					updateUIWhenReady();
				}});
				$.ajax({ url: "./getDataFromFlow.php?userID="+allUsers[3].userID, success: function(data){
					parseDataAndAddToUser(data, allUsers[3]);
					userDataReturnedSoFar++;
					updateUIWhenReady();
				}});
			}
			
			function updateUIWhenReady(){
				if(userDataReturnedSoFar >= allUsers.length){
					updateUI();
					var d = new Date();
					var m =  d.getMinutes();
					if(m < 10){
						m = "0" + m;
					}
					var ampm = "AM";
					var h = d.getHours();
					if(h >= 12){
						h = (h-12);
						ampm = "PM";
					}
					did("headerUpdateTime").innerHTML = " " + h + ":" + m + " " + ampm;
					setTimeout(clearAndLoadAllUserData, AUTO_UPDATE_TIMEOUT);
				}
			}
			
			
			function parseDataAndAddToUser(data, user){
				var lines = data.split("\n");
				for(var i=0; i<lines.length; i++){
					var lArray = lines[i].split(",");
					if(lArray.length == 5){
						var epoch    = lArray[0];
						var fullDate = lArray[1];
						var secs     = lArray[2];
						var ticks    = lArray[3];
						var temp     = lArray[4];
						user.addDataPt(new DataPt(epoch, fullDate, secs, ticks, temp));
					}
				}
			}
			
			var GALLONS_PER_TICK = (0.3 * 1.77 / 3.78541) / 60.0;
												     // 1 kWh is equal to 3600000 joule.
			var JOULES_PER_GALLON_PUMPING   = 0;     // SUPPLY AND CONVEYANCE: 0-16000 kWh/Million gallons  >>    0 - 57600 J/Gal <!-- 540 kWh per million gallons from a depth of 120 feet, 2000 kWh per million gallons from 400 feet (Cohen et al., 2004)-->
			var JOULES_PER_GALLON_TRANSPORT = 6300;  // TREATMENT AND DISTRO: 800-2700 kWh/Million gallons  >> 2880 -  9720 J/Gal (Median = 6300)
			var JOULES_PER_GALLON_CLEANING  = 10260; // WASTEWATER TREATMENT: 1100-4600 kWh/Million gallons >> 3960 - 16560 J/Gal (Median = 10260)
			var DEGREE_C_PER_TEMP_UNIT      = 0.25;  // 0.365 >> 12.5C - 50C; 0.25 >> 20C - 45C
			var KG_PER_GALLON               = 3.7854118;
			var COST_PER_GALLON = 0.018;  //.01716 = residential >> assuming water + sewage
			var WATER_CP = 4184; // Cp of H2O = 1.00 Cal/g-C = 4184 J/kg-C
			var JOULES_PER_GALLON_DEGREE_HEATING = KG_PER_GALLON * WATER_CP; // Q[J] = mass[kg] * Cp[J/Kg-C] * deltaT[C]
			var SEC_PER_DAY = 60*60*24;
			
			
			var MIN_PER_SEGMENT = 5;
			var TICKS_GRAPH_MULTIPLIER_TODAY = 0.02;
			var GRAPH_HEIGHT =  75;
			var GRAPH_WIDTH  = 288;
			var TICKS_GRAPH_MULTIPLIER_THISWEEK = 0.002;
			var TICKS_GRAPH_MULTIPLIER_INTEGRAL = 0.002;
			var TEMP_GRAPH_SCALE = 50.0/100.0;
			
			var TOTALS_THIS_DAY   = [];
			var TOTALS_THIS_WEEK  = [];
			var TOTALS_THIS_MONTH = [];
			var TOTALS_THIS_YEAR  = [];
			
			function updateUI(){
				// pre-UI setup...
				var curdate   = new Date();
				var year      = curdate.getYear()+1900;
				var month     = curdate.getMonth()+1; // add 1 because months are 0-11
				var day       = curdate.getDate()
				var dayofweek = curdate.getDay();
				var min       = curdate.getMinutes();
				var hour      = curdate.getHours();
				var epoch     = curdate.getTime();
				
				// setup canvas...
				var canvas = document.getElementById("renderCanvas");  
				var ctx = canvas.getContext("2d"); 
				
				ctx.lineCap  = "round";
				ctx.lineJoin = "round";
				
				// ------------------------
				// Build "water today"
				// ------------------------
				if(specialUserID == 0){
					// SHOW ALL USERS...
					var waterToday = "<table width=280px cellpadding=0 cellspacing=0 style='margin-left: 10px; margin-right: 10px; margin-top: 5px;'>";
					TOTALS_THIS_DAY = [];
					var nowSegment = Math.floor(min / MIN_PER_SEGMENT) + hour*60/MIN_PER_SEGMENT;
					for(var i=0; i<allUsers.length; i++){
						var user = allUsers[i];
						var totalTicksToday = 0;
						var ticksInSegment = 0;
						var lastSegment = 0;
						ctx.clearRect(-5,-5,GRAPH_WIDTH+10,GRAPH_HEIGHT+10); // clear canvas
						ctx.beginPath(); // start a new sequence.
						ctx.strokeStyle = "#FFFFFF"; // #3366FF is a nice blue
						ctx.lineWidth = 2;
						for(var j=0; j<user.data.length; j++){
							var d = user.data[j];
							if(d.day == day && d.month == month && d.year == year){
								var segment = Math.floor(d.min / MIN_PER_SEGMENT) + d.hour*60/MIN_PER_SEGMENT;
								if(segment != lastSegment){
									lastSegment = segment;
									ticksInSegment = 0;
								}
								ticksInSegment += d.ticks;
								totalTicksToday += d.ticks;
								// draw in the line for this segment!
								ctx.moveTo(segment-0.5, GRAPH_HEIGHT-5);
								ctx.lineTo(segment+0, GRAPH_HEIGHT-5 - Math.min(GRAPH_HEIGHT-10, (ticksInSegment*TICKS_GRAPH_MULTIPLIER_TODAY)));
								ctx.lineTo(segment+0.5, GRAPH_HEIGHT-5);
							} 
						}
						ctx.stroke();
						
						TOTALS_THIS_DAY.push(totalTicksToday);
						
						ctx.beginPath(); // start a new sequence.
						ctx.strokeStyle = "#555555";
						ctx.lineWidth = 3;
						ctx.moveTo(0, GRAPH_HEIGHT-5); // baseline
						ctx.lineTo(GRAPH_WIDTH, GRAPH_HEIGHT-5);
						ctx.stroke();
						
						ctx.beginPath(); // start a new sequence.
						ctx.strokeStyle = "#555555";
						ctx.lineWidth = 7;
						ctx.moveTo(0,GRAPH_HEIGHT-5); // segment 0 = midnight.
						ctx.lineTo(0, GRAPH_HEIGHT);
						ctx.moveTo(96,GRAPH_HEIGHT-5); // segment 96 = 8AM
						ctx.lineTo(96, GRAPH_HEIGHT);
						//ctx.moveTo(144,55); // segment 144 = Noon
						//ctx.lineTo(144, 60);
						ctx.moveTo(216,GRAPH_HEIGHT-5); // segment 216 = 6PM
						ctx.lineTo(216, GRAPH_HEIGHT);
						ctx.moveTo(GRAPH_WIDTH,GRAPH_HEIGHT-5); // segment 288 = midnight
						ctx.lineTo(GRAPH_WIDTH, GRAPH_HEIGHT);
						ctx.stroke();
						
						// draw current time indicator.
						ctx.beginPath(); // start a new sequence.
						ctx.strokeStyle = 'rgba(50,180,50,0.5)'; //"#337733";
						ctx.lineWidth = 2;
						ctx.moveTo(nowSegment+2,GRAPH_HEIGHT+1); // segment 0 = midnight.
						ctx.lineTo(nowSegment+2, 0);
						ctx.stroke();
						var galToday = (totalTicksToday*GALLONS_PER_TICK);
						// todayName, number, sparkline
						var dataURL = canvas.toDataURL("image/png");
						//waterToday += "<div class='todayEntry' style='top: "+(25*i)+"px'><div class='todayName'>" + user.userName + "</div><div class='todayNumber'>" + galToday + "</div><div class='todaySparkline'><img src='"+dataURL+"' style='width: 96px; height: 25px;'/></div></div>";
						waterToday += "<tr><td valign=bottom><span style='color: "+user.hexColor+"'>" + user.userName + "</span></td><td valign=bottom align=right>" +  getDoubleDecimalForPrinting(galToday) + "</td><td valign=bottom align=right><img src='"+dataURL+"' style='width: 96px; height: 25px;'/></td></tr>";
					}
					did("waterToday").innerHTML = waterToday + "</table>";
				}else{
					// SPECIALIZED TO ONE USER...
					// Graph actually shows just last minute of water use!
					TOTALS_THIS_DAY = [];
					var nowSegment = Math.floor(min / MIN_PER_SEGMENT) + hour*60/MIN_PER_SEGMENT;
					for(var i=0; i<allUsers.length; i++){
						var user = allUsers[i];
						if(user.userID != specialUserID){
							continue;
						}
						var totalTicksToday = 0;
						var ticksInSegment = 0;
						var lastSegment = 0;
						ctx.clearRect(-5,-5,GRAPH_WIDTH+10,GRAPH_HEIGHT+10); // clear canvas
						ctx.beginPath(); // start a new sequence.
						ctx.strokeStyle = "#3366FF"; // #3366FF is a nice blue
						ctx.fillStyle = "#3366FF";
						ctx.lineWidth = 3;
						var TOTAL_HIST_SECONDS = 90;
						var samplesInRange = 0;
						var secsPerSample = 1;
						var segWidth = (GRAPH_WIDTH/TOTAL_HIST_SECONDS);
						var lastY = 0;
						for(var j=0; j<user.data.length; j++){
							var d = user.data[j];
							var timeDiff = (curdate/1000-100) - d.epoch;
							//console.log(timeDiff);
							if(timeDiff < TOTAL_HIST_SECONDS && timeDiff >= 0){
								var startTimeDiff = timeDiff + d.secs;
								var segHeight = d.ticks / d.secs;
								var endX = Math.floor((TOTAL_HIST_SECONDS-timeDiff) * segWidth);
								var startX = Math.floor((TOTAL_HIST_SECONDS-startTimeDiff) * segWidth);
								
								console.log("Segment X: ("+startX+", "+endX+") at H = " + segHeight );
								
								ctx.moveTo(startX, GRAPH_HEIGHT-5);
								ctx.lineTo(startX, GRAPH_HEIGHT-5 - Math.min(GRAPH_HEIGHT-15, segHeight*2.0));
								ctx.lineTo(endX, GRAPH_HEIGHT-5 - Math.min(GRAPH_HEIGHT-15, segHeight*2.0));
								ctx.lineTo(endX, GRAPH_HEIGHT-5);
								
								samplesInRange++;
								totalTicksToday += d.ticks;
								
								
								/*
								if(segment != lastSegment){
									lastSegment = segment;
									ticksInSegment = 0;
								}
								console.log("Segment ["+samplesInRange+"] = " + segment + ", timediff=" + timeDiff);
								ticksInSegment += d.ticks;
								totalTicksToday += d.ticks;
								// draw in the line for this segment!
								ctx.moveTo(segment-segWidth*secsPerSample, GRAPH_HEIGHT-5 - lastY);
								var nextY = Math.min(GRAPH_HEIGHT-15, (ticksInSegment*TICKS_GRAPH_MULTIPLIER_TODAY*25.0));
								ctx.lineTo(segment+0, GRAPH_HEIGHT-5 - nextY);
								//lastY = nextY;
								ctx.lineTo(segment+segWidth*secsPerSample, GRAPH_HEIGHT-5);
								*/
							}
							/*
							if(d.day == day && d.month == month && d.year == year){
								var segment = Math.floor(d.min / MIN_PER_SEGMENT) + d.hour*60/MIN_PER_SEGMENT;
								if(segment != lastSegment){
									lastSegment = segment;
									ticksInSegment = 0;
								}
								ticksInSegment += d.ticks;
								totalTicksToday += d.ticks;
								// draw in the line for this segment!
								ctx.moveTo(segment-0.5, GRAPH_HEIGHT-5);
								ctx.lineTo(segment+0, GRAPH_HEIGHT-5 - Math.min(GRAPH_HEIGHT-15, (ticksInSegment*TICKS_GRAPH_MULTIPLIER_TODAY*1.5)));
								ctx.lineTo(segment+0.5, GRAPH_HEIGHT-5);
							} 
							*/
						}
						console.log("Samples is range: " + samplesInRange);
						ctx.stroke();
						ctx.fill();
						
						TOTALS_THIS_DAY.push(totalTicksToday);
						
						ctx.beginPath(); // start a new sequence.
						ctx.strokeStyle = "#555555";
						ctx.lineWidth = 3;
						ctx.moveTo(0, GRAPH_HEIGHT-5); // baseline
						ctx.lineTo(GRAPH_WIDTH, GRAPH_HEIGHT-5);
						ctx.stroke();
						
						ctx.beginPath(); // start a new sequence.
						ctx.strokeStyle = "#555555";
						ctx.lineWidth = 3;
						var SEG_LINES = (TOTAL_HIST_SECONDS/15)+1;
						for(var n=0; n<SEG_LINES; n++){
							ctx.moveTo(n*GRAPH_WIDTH/(SEG_LINES-1)-1,GRAPH_HEIGHT-5);
							ctx.lineTo(n*GRAPH_WIDTH/(SEG_LINES-1)-1, GRAPH_HEIGHT);
						}
						ctx.stroke();
						
						/*
						ctx.beginPath(); // start a new sequence.
						ctx.strokeStyle = "#333333";
						ctx.lineWidth = 1;
						ctx.moveTo(8*GRAPH_WIDTH/23-1, 15);
						ctx.lineTo(8*GRAPH_WIDTH/23-1, GRAPH_HEIGHT);
						ctx.moveTo(12*GRAPH_WIDTH/23-1, 15);
						ctx.lineTo(12*GRAPH_WIDTH/23-1, GRAPH_HEIGHT);
						ctx.moveTo(18*GRAPH_WIDTH/23-1, 15);
						ctx.lineTo(18*GRAPH_WIDTH/23-1, GRAPH_HEIGHT);
						ctx.stroke();
						
						ctx.beginPath();
						ctx.font = "12px Helvetica, sans-serif";
						ctx.fillStyle = "#CCCCCC";
						ctx.fillText("8AM", 8*GRAPH_WIDTH/23-12, 10);
						ctx.fillText("Noon", 12*GRAPH_WIDTH/23-16, 10);
						ctx.fillText("6PM", 18*GRAPH_WIDTH/23-12, 10);
						*/
						
						/*
						ctx.beginPath(); // start a new sequence.
						ctx.strokeStyle = "#555555";
						ctx.lineWidth = 3;
						ctx.moveTo(0,GRAPH_HEIGHT-5); // segment 0 = midnight.
						ctx.lineTo(0, GRAPH_HEIGHT);
						ctx.moveTo(96,GRAPH_HEIGHT-5); // segment 96 = 8AM
						ctx.lineTo(96, GRAPH_HEIGHT);
						//ctx.moveTo(144,55); // segment 144 = Noon
						//ctx.lineTo(144, 60);
						ctx.moveTo(216,GRAPH_HEIGHT-5); // segment 216 = 6PM
						ctx.lineTo(216, GRAPH_HEIGHT);
						ctx.moveTo(GRAPH_WIDTH,GRAPH_HEIGHT-5); // segment 288 = midnight
						ctx.lineTo(GRAPH_WIDTH, GRAPH_HEIGHT);
						ctx.stroke();
						*/
						
						// draw current time indicator.
						/*
						ctx.beginPath(); // start a new sequence.
						ctx.strokeStyle = 'rgba(50,180,50,1.0)'; //"#337733";
						ctx.lineWidth = 1;
						ctx.moveTo(nowSegment,GRAPH_HEIGHT+1); // segment 0 = midnight.
						ctx.lineTo(nowSegment, 15);
						ctx.stroke();
						ctx.fillStyle = "#CCCCCC";
						//ctx.fillText("Now", nowSegment-9, 10);
						*/
						
						var galToday = (totalTicksToday*GALLONS_PER_TICK);
						var dataURL = canvas.toDataURL("image/png");
						did("waterToday").innerHTML = "<div style='margin-top: 5px; text-align: center;'><!--<span>"+user.userName+"</span> &nbsp; &nbsp; --><span style='color: #FF6666;'>&nbsp;"+getSingleDecimalForPrinting(galToday)+" gal.</span><img src='"+dataURL+"' style='width: 288px; height: 75px; margin-top: 5px; margin-left: 3px;'/></div>";
					}
				}
					
				// ------------------------
				// Build "water integral today"
				// ------------------------
				
				var nowSegment = Math.floor(min / MIN_PER_SEGMENT) + hour*60/MIN_PER_SEGMENT;
				ctx.clearRect(-5,-5,GRAPH_WIDTH+10,GRAPH_HEIGHT+10); // clear canvas
				for(var i=0; i<allUsers.length; i++){
					var user = allUsers[i];
					if(specialUserID != 0 && user.userID != specialUserID){
						continue;
					}
					var totalTicksToday = 0;
					var ticksInSegment = 0;
					var lastSegment = 0;
					ctx.beginPath(); // start a new sequence.
					ctx.strokeStyle = user.hexColor;
					ctx.lineWidth = 2;
					for(var j=0; j<user.data.length; j++){
						var d = user.data[j];
						if(d.day == day && d.month == month && d.year == year){
							var segment = Math.floor(d.min / MIN_PER_SEGMENT) + d.hour*60/MIN_PER_SEGMENT;
							var prevTicks = totalTicksToday;
							totalTicksToday += d.ticks;
							// draw in the line for this segment!
							ctx.moveTo(lastSegment, GRAPH_HEIGHT-5 - Math.min(GRAPH_HEIGHT-10, (prevTicks*TICKS_GRAPH_MULTIPLIER_INTEGRAL)));
							ctx.lineTo(segment, GRAPH_HEIGHT-5 - Math.min(GRAPH_HEIGHT-10, (totalTicksToday*TICKS_GRAPH_MULTIPLIER_INTEGRAL)));
							if(segment != lastSegment){
								lastSegment = segment;
							}
						} 
					}
					if(lastSegment < nowSegment){
						ctx.moveTo(lastSegment, GRAPH_HEIGHT-5 - Math.min(GRAPH_HEIGHT-10, (totalTicksToday*TICKS_GRAPH_MULTIPLIER_INTEGRAL)));
						ctx.lineTo(nowSegment, GRAPH_HEIGHT-5 - Math.min(GRAPH_HEIGHT-10, (totalTicksToday*TICKS_GRAPH_MULTIPLIER_INTEGRAL)));
					}
					ctx.stroke();
					
					ctx.beginPath(); // start a new sequence.
					ctx.strokeStyle = "#555555";
					ctx.lineWidth = 3;
					ctx.moveTo(0, GRAPH_HEIGHT-5); // baseline
					ctx.lineTo(GRAPH_WIDTH, GRAPH_HEIGHT-5);
					ctx.stroke();
					
					ctx.beginPath(); // start a new sequence.
					ctx.strokeStyle = "#555555";
					ctx.lineWidth = 3;
					ctx.moveTo(0,GRAPH_HEIGHT-5); // segment 0 = midnight.
					ctx.lineTo(0, GRAPH_HEIGHT);
					ctx.moveTo(96,GRAPH_HEIGHT-5); // segment 96 = 8AM
					ctx.lineTo(96, GRAPH_HEIGHT);
					//ctx.moveTo(144,55); // segment 144 = Noon
					//ctx.lineTo(144, 60);
					ctx.moveTo(216,GRAPH_HEIGHT-5); // segment 216 = 6PM
					ctx.lineTo(216, GRAPH_HEIGHT);
					ctx.moveTo(GRAPH_WIDTH,GRAPH_HEIGHT-5); // segment 288 = midnight
					ctx.lineTo(GRAPH_WIDTH, GRAPH_HEIGHT);
					ctx.stroke();
					
					// draw current time indicator.
					ctx.beginPath(); // start a new sequence.
					ctx.strokeStyle = 'rgba(50,180,50,0.5)'; //"#337733";
					ctx.lineWidth = 1;
					ctx.moveTo(nowSegment,GRAPH_HEIGHT+1); // segment 0 = midnight.
					ctx.lineTo(nowSegment, 15);
					ctx.stroke();
					ctx.fillStyle = "#CCCCCC";
					ctx.fillText("Now", nowSegment-9, 10);
					
				}
				var dataURL = canvas.toDataURL("image/png");
				did("waterIntegral").innerHTML = "<img src='"+dataURL+"' style='width: 288px; height: 75px; margin-top: 25px; margin-left: 3px;'/>";
				
				// ------------------------
				// build water this week.
				// ------------------------
				ctx.clearRect(-5,-5,GRAPH_WIDTH+10,GRAPH_HEIGHT+10); // clear canvas
				TOTALS_THIS_WEEK = [];
				for(var i=0; i<allUsers.length; i++){
					var user = allUsers[i];
					if(specialUserID != 0 && user.userID != specialUserID){
						continue;
					}
					var userDaySegments = []; // new Array();
					
					for(var n=0; n <= dayofweek; n++){
						var testDate      = new Date(curdate.getTime() - 1000*60*60*24*(dayofweek-n));
						var testYear      = testDate.getYear()+1900;
						var testMonth     = testDate.getMonth()+1; // add 1 because months are 0-11
						var testDay       = testDate.getDate();
						userDaySegments.push(0);
						for(var j=0; j<user.data.length; j++){
							var d = user.data[j];
							if(d.day == testDay && d.month == testMonth && d.year == testYear){
								userDaySegments[n] += d.ticks;
							} 
						}
					}
					
					ctx.beginPath(); // start a new sequence.
					ctx.strokeStyle = user.hexColor;
					ctx.lineWidth = 2;
					ctx.moveTo(0, GRAPH_HEIGHT-5-userDaySegments[0]*TICKS_GRAPH_MULTIPLIER_THISWEEK);
					for(var n=0; n <= dayofweek; n++){
						ctx.lineTo(n*GRAPH_WIDTH/6, GRAPH_HEIGHT-5-userDaySegments[n]*TICKS_GRAPH_MULTIPLIER_THISWEEK);
					}
					ctx.stroke();
					TOTALS_THIS_WEEK.push(userDaySegments);
				}
				
				ctx.beginPath(); // start a new sequence.
				ctx.strokeStyle = "#555555";
				ctx.lineWidth = 3;
				ctx.moveTo(0, GRAPH_HEIGHT-5); // baseline
				ctx.lineTo(GRAPH_WIDTH, GRAPH_HEIGHT-5);
				ctx.stroke();

				ctx.beginPath(); // start a new sequence.
				ctx.strokeStyle = "#555555";
				ctx.lineWidth = 3;
				for(var n=0; n<7; n++){
					ctx.moveTo(n*GRAPH_WIDTH/6-1,GRAPH_HEIGHT-5);
					ctx.lineTo(n*GRAPH_WIDTH/6-1, GRAPH_HEIGHT);
				}
				ctx.stroke();
				
				ctx.beginPath();
				ctx.font = "12px Helvetica, sans-serif";
				ctx.fillStyle = "#CCCCCC";
				ctx.fillText("Sun", 0*GRAPH_WIDTH/6-0, 10);
				ctx.fillText("Mon", 1*GRAPH_WIDTH/6-10, 10);
				ctx.fillText("Tue", 2*GRAPH_WIDTH/6-10, 10);
				ctx.fillText("Wed", 3*GRAPH_WIDTH/6-10, 10);
				ctx.fillText("Thu", 4*GRAPH_WIDTH/6-10, 10);
				ctx.fillText("Fri", 5*GRAPH_WIDTH/6-10, 10);
				ctx.fillText("Sat", 6*GRAPH_WIDTH/6-20, 10);
				
				var dataURL = canvas.toDataURL("image/png");
				did("waterThisWeek").innerHTML = "<img src='"+dataURL+"' style='width: 288px; height: 75px; margin-top: 25px; margin-left: 3px;'/>";
				
				// ------------------------
				// build water this month.
				// ------------------------
				ctx.clearRect(-5,-5,GRAPH_WIDTH+10,GRAPH_HEIGHT+10); // clear canvas
				for(var i=0; i<allUsers.length; i++){
					var user = allUsers[i];
					if(specialUserID != 0 && user.userID != specialUserID){
						continue;
					}
					var userMonthSegments = []; // new Array();
					for(var n=0; n < day; n++){
						var testDate      = new Date(curdate.getTime() - 1000*60*60*24*(day-n-1));
						var testYear      = testDate.getYear()+1900;
						var testMonth     = testDate.getMonth()+1; // add 1 because months are 0-11
						var testDay       = testDate.getDate();
						userMonthSegments.push(0);
						for(var j=0; j<user.data.length; j++){
							var d = user.data[j];
							if(d.day == testDay && d.month == testMonth && d.year == testYear){
								userMonthSegments[n] += d.ticks;
							} 
						}
					}
					ctx.beginPath(); // start a new sequence.
					ctx.strokeStyle = user.hexColor;
					ctx.lineWidth = 2;
					ctx.moveTo(0, GRAPH_HEIGHT-5-userMonthSegments[0]*TICKS_GRAPH_MULTIPLIER_THISWEEK);
					for(var n=0; n < day; n++){
						ctx.lineTo(n*GRAPH_WIDTH/30, GRAPH_HEIGHT-5-userMonthSegments[n]*TICKS_GRAPH_MULTIPLIER_THISWEEK);
					}
					ctx.stroke();
				}
				
				ctx.beginPath(); // start a new sequence.
				ctx.strokeStyle = "#555555";
				ctx.lineWidth = 3;
				ctx.moveTo(0, GRAPH_HEIGHT-5); // baseline
				ctx.lineTo(GRAPH_WIDTH, GRAPH_HEIGHT-5);
				ctx.stroke();
				
				ctx.beginPath(); // start a new sequence.
				ctx.strokeStyle = "#555555";
				ctx.lineWidth = 2;
				for(var n=0; n<31; n++){
					ctx.moveTo(n*GRAPH_WIDTH/30-1,GRAPH_HEIGHT-5);
					ctx.lineTo(n*GRAPH_WIDTH/30-1, GRAPH_HEIGHT);
				}
				ctx.stroke();
				
				ctx.beginPath(); // start a new sequence.
				ctx.strokeStyle = "#333333";
				ctx.lineWidth = 1;
				ctx.moveTo(4*GRAPH_WIDTH/30-1, 15);
				ctx.lineTo(4*GRAPH_WIDTH/30-1, GRAPH_HEIGHT);
				ctx.moveTo(9*GRAPH_WIDTH/30-1, 15);
				ctx.lineTo(9*GRAPH_WIDTH/30-1, GRAPH_HEIGHT);
				ctx.moveTo(14*GRAPH_WIDTH/30-1, 15);
				ctx.lineTo(14*GRAPH_WIDTH/30-1, GRAPH_HEIGHT);
				ctx.moveTo(19*GRAPH_WIDTH/30-1, 15);
				ctx.lineTo(19*GRAPH_WIDTH/30-1, GRAPH_HEIGHT);
				ctx.moveTo(24*GRAPH_WIDTH/30-1, 15);
				ctx.lineTo(24*GRAPH_WIDTH/30-1, GRAPH_HEIGHT);
				ctx.moveTo(29*GRAPH_WIDTH/30-1, 15);
				ctx.lineTo(29*GRAPH_WIDTH/30-1, GRAPH_HEIGHT);
				ctx.stroke();
				
				ctx.beginPath();
				ctx.font = "12px Helvetica, sans-serif";
				ctx.fillStyle = "#CCCCCC";
				ctx.fillText("5",   4*GRAPH_WIDTH/30-4, 10);
				ctx.fillText("10",  9*GRAPH_WIDTH/30-8, 10);
				ctx.fillText("15", 14*GRAPH_WIDTH/30-8, 10);
				ctx.fillText("20", 19*GRAPH_WIDTH/30-8, 10);
				ctx.fillText("25", 24*GRAPH_WIDTH/30-8, 10);
				ctx.fillText("30", 29*GRAPH_WIDTH/30-10, 10);
				
				var dataURL = canvas.toDataURL("image/png");
				did("waterThisMonth").innerHTML = "<img src='"+dataURL+"' style='width: 288px; height: 75px; margin-top: 25px; margin-left: 3px;'/>";

				// ------------------------
				// build total water by time of day.
				// ------------------------
				ctx.clearRect(-5,-5,GRAPH_WIDTH+10,GRAPH_HEIGHT+10); // clear canvas
				for(var i=0; i<allUsers.length; i++){
					var user = allUsers[i];
					if(specialUserID != 0 && user.userID != specialUserID){
						continue;
					}
					var userHourSegments = []; // new Array();
					
					for(var n=0; n < 48; n++){
						userHourSegments.push(0);
					}
					for(var j=0; j<user.data.length; j++){
						var d = user.data[j];
						var seg = Math.min(47, Math.max(0, Math.floor(d.hour*2+Math.floor(d.min/30))));
						userHourSegments[seg] += d.ticks;
					}
					var maxSeg = 1000;
					for(var n=0; n < 48; n++){
						if(maxSeg < userHourSegments[n]){
							maxSeg = userHourSegments[n];
						}
					}
					var autoScale = (GRAPH_HEIGHT-25.0) / maxSeg;
					
					ctx.beginPath(); // start a new sequence.
					ctx.strokeStyle = user.hexColor;
					ctx.lineWidth = 2;
					ctx.moveTo(0, GRAPH_HEIGHT-5-userHourSegments[0]*autoScale);
					for(var n=0; n < 48; n++){
						//ctx.moveTo((n-0.5)*GRAPH_WIDTH/47, GRAPH_HEIGHT-5-userHourSegments[n]*autoScale); // THIS MAKES THE GRAPH DISCONTINOUS
						ctx.lineTo((n)*GRAPH_WIDTH/47, GRAPH_HEIGHT-5-userHourSegments[n]*autoScale);
					}
					ctx.stroke();
				}
				
				ctx.beginPath(); // start a new sequence.
				ctx.strokeStyle = "#555555";
				ctx.lineWidth = 3;
				ctx.moveTo(0, GRAPH_HEIGHT-5); // baseline
				ctx.lineTo(GRAPH_WIDTH, GRAPH_HEIGHT-5);
				ctx.stroke();

				ctx.beginPath(); // start a new sequence.
				ctx.strokeStyle = "#555555";
				ctx.lineWidth = 3;
				for(var n=0; n<24; n++){
					ctx.moveTo(n*GRAPH_WIDTH/23-1,GRAPH_HEIGHT-5);
					ctx.lineTo(n*GRAPH_WIDTH/23-1, GRAPH_HEIGHT);
				}
				ctx.stroke();
				
				ctx.beginPath(); // start a new sequence.
				ctx.strokeStyle = "#333333";
				ctx.lineWidth = 1;
				ctx.moveTo(8*GRAPH_WIDTH/23-1, 15);
				ctx.lineTo(8*GRAPH_WIDTH/23-1, GRAPH_HEIGHT);
				ctx.moveTo(12*GRAPH_WIDTH/23-1, 15);
				ctx.lineTo(12*GRAPH_WIDTH/23-1, GRAPH_HEIGHT);
				ctx.moveTo(18*GRAPH_WIDTH/23-1, 15);
				ctx.lineTo(18*GRAPH_WIDTH/23-1, GRAPH_HEIGHT);
				ctx.stroke();
				
				
				ctx.beginPath();
				ctx.font = "12px Helvetica, sans-serif";
				ctx.fillStyle = "#CCCCCC";
				ctx.fillText("8AM", 8*GRAPH_WIDTH/23-12, 10);
				ctx.fillText("Noon", 12*GRAPH_WIDTH/23-16, 10);
				ctx.fillText("6PM", 18*GRAPH_WIDTH/23-12, 10);
				
				var dataURL = canvas.toDataURL("image/png");
				did("waterDayAverage").innerHTML = "<img src='"+dataURL+"' style='width: 288px; height: 75px; margin-top: 25px; margin-left: 3px;'/>";
				
				// ------------------------
				// build average water temp by time of day.
				// ------------------------
				ctx.clearRect(-5,-5,GRAPH_WIDTH+10,GRAPH_HEIGHT+10); // clear canvas
				for(var i=0; i<allUsers.length; i++){
					var user = allUsers[i];
					if(specialUserID != 0 && user.userID != specialUserID){
						continue;
					}
					var userHourTempSegments = []; // new Array();
					var userHourTempEntries  = []; // entries added so far (needed for averaging).
					
					for(var n=0; n < 48; n++){
						userHourTempSegments.push(0);
						userHourTempEntries.push(0);
					}
					for(var j=0; j<user.data.length; j++){
						var d = user.data[j];
						if(d.ticks > 0){
							// only use temp data when water is flowing (not startup temp).
							var seg = Math.min(47, Math.max(0, Math.floor(d.hour*2+Math.floor(d.min/30))));
							userHourTempSegments[seg] += Math.max(0, Math.min(100, d.temp));
							userHourTempEntries[seg]++;
						}
					}
					for(var n=0; n < 48; n++){
						if(userHourTempEntries[n] > 0){
							userHourTempSegments[n] = userHourTempSegments[n]/userHourTempEntries[n];
							if(maxSeg < userHourTempSegments[n]){
								maxSeg = userHourTempSegments[n];
							}
						}else{
							userHourTempSegments[n] = 0; // put at center temp if we don't have any info.
						}
					}
					ctx.beginPath(); // start a new sequence.
					ctx.strokeStyle = user.hexColor;
					ctx.lineWidth = 2;
					ctx.moveTo(0, GRAPH_HEIGHT-5 - userHourTempSegments[0]*TEMP_GRAPH_SCALE);
					for(var n=0; n < 48; n++){
						//ctx.moveTo((n-0.5)*GRAPH_WIDTH/47, GRAPH_HEIGHT-5 - userHourTempSegments[n]*TEMP_GRAPH_SCALE); // THIS MAKES THE GRAPH DISCONTINOUS
						ctx.lineTo((n)*GRAPH_WIDTH/47, GRAPH_HEIGHT-5 - userHourTempSegments[n]*TEMP_GRAPH_SCALE);
					}
					ctx.stroke();
				}
				
				ctx.beginPath(); // start a new sequence.
				ctx.strokeStyle = "#555555";
				ctx.lineWidth = 3;
				ctx.moveTo(0, GRAPH_HEIGHT-5); // baseline
				ctx.lineTo(GRAPH_WIDTH, GRAPH_HEIGHT-5);
				ctx.stroke();

				ctx.beginPath(); // start a new sequence.
				ctx.strokeStyle = "#555555";
				ctx.lineWidth = 3;
				for(var n=0; n<24; n++){
					ctx.moveTo(n*GRAPH_WIDTH/23-1,GRAPH_HEIGHT-5);
					ctx.lineTo(n*GRAPH_WIDTH/23-1, GRAPH_HEIGHT);
				}
				ctx.stroke();
				
				ctx.beginPath(); // start a new sequence.
				ctx.strokeStyle = "#333333";
				ctx.lineWidth = 1;
				ctx.moveTo(8*GRAPH_WIDTH/23-1, 15);
				ctx.lineTo(8*GRAPH_WIDTH/23-1, GRAPH_HEIGHT);
				ctx.moveTo(12*GRAPH_WIDTH/23-1, 15);
				ctx.lineTo(12*GRAPH_WIDTH/23-1, GRAPH_HEIGHT);
				ctx.moveTo(18*GRAPH_WIDTH/23-1, 15);
				ctx.lineTo(18*GRAPH_WIDTH/23-1, GRAPH_HEIGHT);
				ctx.stroke();
				
				ctx.beginPath();
				ctx.font = "12px Helvetica, sans-serif";
				ctx.fillStyle = "#CCCCCC";
				ctx.fillText("8AM", 8*GRAPH_WIDTH/23-12, 10);
				ctx.fillText("Noon", 12*GRAPH_WIDTH/23-16, 10);
				ctx.fillText("6PM", 18*GRAPH_WIDTH/23-12, 10);
				
				var dataURL = canvas.toDataURL("image/png");
				did("waterDayAveTemp").innerHTML = "<img src='"+dataURL+"' style='width: 288px; height: 75px; margin-top: 25px; margin-left: 3px;'/>";
				
				// ------------------------
				// Build "water this month"
				// ------------------------
				TOTALS_THIS_MONTH = [];
				for(var i=0; i<allUsers.length; i++){
					var user = allUsers[i];
					var totalTicksThisMonth = 0;
					for(var j=0; j<user.data.length; j++){
						var d = user.data[j];
						if(d.month == month && d.year == year){
							totalTicksThisMonth += d.ticks;
						} 
					}
					TOTALS_THIS_MONTH.push(totalTicksThisMonth);
				}
				
				// ------------------------
				// Build "water this month"
				// ------------------------
				TOTALS_THIS_YEAR  = [];
				for(var i=0; i<allUsers.length; i++){
					var user = allUsers[i];
					var totalTicksThisYear = 0;
					for(var j=0; j<user.data.length; j++){
						var d = user.data[j];
						if(d.year == year){
							totalTicksThisYear += d.ticks;
						} 
					}
					TOTALS_THIS_YEAR.push(totalTicksThisYear);
				}
				
				// ------------------------
				// Build "water cost"
				// ------------------------
				var waterCost = "<table width=280px cellpadding=0 cellspacing=0 style='margin-left: 10px; margin-right: 10px; margin-top: 20px;'>";
				waterCost += "<tr style='font-size: 12px;'><td align='right' width='25%'>Day</td><td align='right' width='25%'>Week</td><td align='right' width='25%'>Month</td><td align='right' width='25%'>Year</td></tr>";
				for (var i=0; i<allUsers.length; i++){
					var user = allUsers[i];
					if(specialUserID != 0 && user.userID != specialUserID){
						continue;
					}
					var costDay = TOTALS_THIS_DAY[i] * GALLONS_PER_TICK * COST_PER_GALLON;
					waterCost += "<tr><td align='right'><span style='font-size: 14px; color: "+user.hexColor+";'>"+getDoubleDecimalForPrinting(costDay)+"</td>";
					var ticksWeek = 0;
					var myWeek = TOTALS_THIS_WEEK[i];
					for(var d=0; d<myWeek.length; d++){
						ticksWeek += myWeek[d];
					}
					var costWeek = ticksWeek * GALLONS_PER_TICK * COST_PER_GALLON;
					waterCost += "<td align='right'><span style='font-size: 14px; color: "+user.hexColor+";'>"+getDoubleDecimalForPrinting(costWeek)+"</td>";
					var costMonth = TOTALS_THIS_MONTH[i] * GALLONS_PER_TICK * COST_PER_GALLON;
					waterCost += "<td align='right'><span style='font-size: 14px; color: "+user.hexColor+";'>"+getDoubleDecimalForPrinting(costMonth)+"</td>";
					var costYear = TOTALS_THIS_YEAR[i] * GALLONS_PER_TICK * COST_PER_GALLON;
					waterCost += "<td align='right'><span style='font-size: 14px; color: "+user.hexColor+";'>"+getDoubleDecimalForPrinting(costYear)+"</td>";
					waterCost += "</tr>";
				}
				did("waterCost").innerHTML = waterCost + "</table>";
				
				// ------------------------
				// Build "water power"
				// ------------------------
				var waterCost = "<table width=280px cellpadding=0 cellspacing=0 style='margin-left: 10px; margin-right: 10px; margin-top: 20px;'>";
				waterCost += "<tr style='font-size: 12px;'><td align='right' width='25%'>Transport</td><td align='right' width='25%'>Heating</td><td align='right' width='25%'>Cleaning</td><td align='right' width='25%'>Total</td></tr>";
				for (var i=0; i<allUsers.length; i++){
					var user = allUsers[i];
					if(specialUserID != 0 && user.userID != specialUserID){
						continue;
					}
					// get data from past 24 hours...
					var lastDayEpoch = epoch/1000 - 60*60*24;
					var transportJoules = 0;
					var heatingJoules   = 0;
					var cleaningJoules  = 0;
					for(var p=0; p<user.data.length; p++){
						var d = user.data[p];
						if(d.epoch >= lastDayEpoch){
							// useful data...
							var gallons = d.ticks*GALLONS_PER_TICK;
							var degreesAboveGroundTemp = (Math.max(0, Math.min(100, d.temp))*DEGREE_C_PER_TEMP_UNIT); // deltaT
							transportJoules += gallons * JOULES_PER_GALLON_TRANSPORT;
							heatingJoules   += gallons * degreesAboveGroundTemp * JOULES_PER_GALLON_DEGREE_HEATING;
							cleaningJoules  += gallons * JOULES_PER_GALLON_CLEANING;
						}
					}
					var transportWatts = transportJoules / SEC_PER_DAY;
					var heatingWatts   = heatingJoules / SEC_PER_DAY;
					var cleaningWatts  = cleaningJoules / SEC_PER_DAY;
					var totalWatts     = transportWatts + heatingWatts + cleaningWatts;
					waterCost += "<tr><td align='right'><span style='font-size: 14px; color: "+user.hexColor+";'>"+getDoubleDecimalForPrinting(transportWatts)+"</td>";
					waterCost += "<td align='right'><span style='font-size: 14px; color: "+user.hexColor+";'>"+getDoubleDecimalForPrinting(heatingWatts)+"</td>";
					waterCost += "<td align='right'><span style='font-size: 14px; color: "+user.hexColor+";'>"+getDoubleDecimalForPrinting(cleaningWatts)+"</td>";
					waterCost += "<td align='right'><span style='font-size: 14px; color: "+user.hexColor+";'>"+getDoubleDecimalForPrinting(totalWatts)+"</td>";
					waterCost += "</tr>";
				}
				did("waterPower").innerHTML = waterCost + "</table>";
				
				// ------------------------
				// DEBUG Info
				// ------------------------
				var RESTART_TIMES = [];
				var debugHTML = "<table width=280px cellpadding=0 cellspacing=0 style='margin-left: 10px; margin-right: 10px; margin-top: 20px;'>";
				debugHTML += "<tr style='font-size: 12px;'><td align='right' width='50%'>Last Seen</td></tr>";
				for (var i=0; i<allUsers.length; i++){
					var user = allUsers[i];
					if(specialUserID != 0 && user.userID != specialUserID){
						continue;
					}
					var userTimes = [];
					lastTime = 0;
					for(var j=0; j<user.data.length; j++){
						var d = user.data[j];
						if(d.ticks == 0){
							userTimes.push(d);
						}
						if(lastTime == 0 || d.epoch > lastTime.epoch){
							lastTime = d;
						} 
					}
					if(lastTime != 0){
						debugHTML += "<tr><td align='right'><span style='font-size: 14px; color: "+user.hexColor+";'>"+lastTime.year+"-"+lastTime.month+"-"+lastTime.day;
						var ampm = "AM";
						var h = lastTime.hour;
						if(h >= 12){
							h -= 12;
							ampm = "PM";
						}
						var m = lastTime.min;
						if(m < 10){
							m = "0" + m;
						}
						debugHTML += " at "+h+":"+m+" "+ampm+"</td></tr>";
					}else{
						debugHTML += "<tr><td align='right'><span style='font-size: 14px; color: "+user.hexColor+";'>waiting for connection</td></tr>";
					}
					RESTART_TIMES[user.userID] = userTimes;
				}
				AAA_FLOW_DEBUG['RESTART_TIMES'] = RESTART_TIMES;
				AAA_FLOW_DEBUG['USERS'] = allUsers;
				
				did("waterDebug").innerHTML = debugHTML + "</table>";
				
			}
			
			var AAA_FLOW_DEBUG = [];
			
			function getDoubleDecimalForPrinting(val){
				var a = Math.floor(val);
				var b = Math.floor((val-a)*10);
				var c = Math.floor((val-a-b/10.0)*100);
				return ""+a+"."+b+""+c;
			}
			
			function getSingleDecimalForPrinting(val){
				var a = Math.floor(val);
				var b = Math.floor((val-a)*10);
				var c = Math.floor((val-a-b/10.0)*100);
				return ""+a+"."+b;
			}
			
			function User(userID, userName, hexColor){
				this.userID = userID;
				this.userName = userName;
				this.hexColor = hexColor;
				this.data = new Array();
				this.addDataPt = function(dataPt){
					this.data.push(dataPt);
				}
			}

			function DataPt(epoch, fullDate, secs, ticks, temp){
				this.epoch     = parseInt(epoch);
				this.fullDate  = fullDate;
				this.secs      = parseInt(parseFloat(secs));
				this.ticks     = parseInt(parseFloat(ticks));
				this.temp      = parseInt(parseFloat(temp));
				this.year      = 2010;
				this.month     = 1;
				this.day       = 1;
				this.dayOfWeek = 1;
				this.hour      = 1;
				this.min       = 1;
				this.sec       = 1;
				var dateArray = fullDate.split("-");
				if(dateArray.length == 7){
					this.year      = parseInt(parseFloat(dateArray[0]));
					this.month     = parseInt(parseFloat(dateArray[1])); 
					this.day       = parseInt(parseFloat(dateArray[2])); 
					this.dayOfWeek = parseInt(parseFloat(dateArray[3])); 
					this.hour      = parseInt(parseFloat(dateArray[4])); 
					this.min       = parseInt(parseFloat(dateArray[5])); 
					this.sec       = parseInt(parseFloat(dateArray[6])); 
				}else{
					console.log("ERR >> could not parse date >> " + fullDate);	
					console.log(dateArray);
				}
			}
		
		
			/* TOUCH CALLBACKS */
			// These enable you to do more advanced things with touches if you want.. not necessary for move/scale/rotate.
			//*
			function touchStart(e){
				// put code here that gets called when a touch is started (finger first touches the screen).
			}
			function touchMove(e){
				// put code here that gets called when a touch is moved (finger dragged on the screen).
			}
			function touchEnd(e){
				// put code here that gets called when a touch is ended (finger lifted from screen). 
				// (movingObjects[id] have been deleted at this point; use the onTouchDown attribute to catch the release earlier).
				// this can be a good place to check for bounds of moved objects and spring them back if needed.
			}
			function touchCancel(e){
				// put code here that gets called when a touch is cancelled (not sure how this is different from End).
				// (movingObjects[id] have been deleted at this point; use the onTouchDown attribute to catch the release earlier).
				touchEnd(e);
			}
			//*/
			
			// this gets called as soon as the DOM is ready (faster than using 'onload').
			$(document).ready(function(){
				// required for using touch: setup touch with callback functions (defined above)...
				//initTouch(touchStart, touchMove, touchEnd, touchCancel);
				
				var canvas = document.getElementById("renderCanvas");  
				var ctx = canvas.getContext("2d"); 
				ctx.translate(0.5, 0.5); // by default, the canvas draws lines on pixel borders (i.e., a 1 px line is blurred across 2 pixels).  this makes straight 1px lines truly 1px. 
				
				setTimeout(getUserData, 250);
			});
			
		//]]>
		</script>	
		<!-- ############################################# -->
		<!-- ######## end of dynamic App content. ######## -->
		<!-- ############################################# -->
				
		<!-- You can put web stats code here -->
		<script type="text/javascript">
		var gaJsHost = (("https:" == document.location.protocol) ? "https://ssl." : "http://www.");
		document.write(unescape("%3Cscript src='" + gaJsHost + "google-analytics.com/ga.js' type='text/javascript'%3E%3C/script%3E"));
		</script>
		<script type="text/javascript">
		try {
		var pageTracker = _gat._getTracker("UA-13029489-1");
		pageTracker._trackPageview();
		} catch(err) {}</script>

	</body>
</html>